/*
*********************************************************************
*								      	                                    *
*                      Copyright (c) 1985,1986,1987, 1988 by        *
*		Digital Equipment Corporation, Maynard, MA		               *
*			All rights reserved.				                           *
*********************************************************************
*/
/*****************************************************************************/
/*      File: COMPOSE.H                                                      */
/*****************************************************************************/

#define ISO_LATIN_1 1

#if ISO_LATIN_1

#define INVERTED_EXCLAMATION 161
#define CENT 162
#define UK_POUND 163
#define YEN 165
#define SECTION 167
#define INT_CURRENCY 164
#define COPYRIGHT 169
#define FEM_ORDINAL 170
#define ANG_QUOTE_LEFT 171

#define DEGREE 176
#define PLUS_MINUS 177
#define SUPERSCRIPT_TWO 178
#define SUPERSCRIPT_THREE 179
#define MU 181
#define PARAGRAPH 182
#define MIDDLE_DOT 183
#define SUPERSCRIPT_ONE 185
#define MASC_ORDINAL 186
#define ANG_QUOTE_RIGHT 187
#define ONE_QUARTER 188
#define ONE_HALF 189
#define INVERTED_QUESTION 191

#define CAPA_GRAVE 192
#define CAPA_ACUTE 193
#define CAPA_CIRCUMFLEX 194
#define CAPA_TILDE 195
#define CAPA_UMLAUT 196
#define CAPA_RING 197
#define CAPAE_LIGATURE 198
#define CAPC_CEDILLA 199
#define CAPE_GRAVE 200
#define CAPE_ACUTE 201
#define CAPE_CIRCUMFLEX 202
#define CAPE_UMLAUT 203
#define CAPI_GRAVE 204
#define CAPI_ACUTE 205
#define CAPI_CIRCUMFLEX 206
#define CAPI_UMLAUT 207

#define CAPN_TILDE 209
#define CAPO_GRAVE 210
#define CAPO_ACUTE 211
#define CAPO_CIRCUMFLEX 212
#define CAPO_TILDE 213
#define CAPO_UMLAUT 214
#define CAPOE_LIGATURE 215
#define CAPO_SLASH 216
#define CAPU_GRAVE 217
#define CAPU_ACUTE 218
#define CAPU_CIRCUMFLEX 219
#define CAPU_UMLAUT 220
#define CAPY_UMLAUT 221
#define GERMAN_SHARP_S 223

#define SMALLA_GRAVE 224
#define SMALLA_ACUTE 225
#define SMALLA_CIRCUMFLEX 226
#define SMALLA_TILDE 227
#define SMALLA_UMLAUT 228
#define SMALLA_RING 229
#define SMALLAE_LIGATURE 230
#define SMALLC_CEDILLA 231
#define SMALLE_GRAVE 232
#define SMALLE_ACUTE 233
#define SMALLE_CIRCUMFLEX 234
#define SMALLE_UMLAUT 235
#define SMALLI_GRAVE 236
#define SMALLI_ACUTE 237
#define SMALLI_CIRCUMFLEX 238
#define SMALLI_UMLAUT 239

#define SMALLN_TILDE 241
#define SMALLO_GRAVE 242
#define SMALLO_ACUTE 243
#define SMALLO_CIRCUMFLEX 244
#define SMALLO_TILDE 245
#define SMALLO_UMLAUT 246
#define SMALLOE_LIGATURE 247
#define SMALLO_SLASH 248
#define SMALLU_GRAVE 249
#define SMALLU_ACUTE 250
#define SMALLU_CIRCUMFLEX 251
#define SMALLU_UMLAUT 252
#define SMALLY_UMLAUT 255

#else
#define INVERTED_EXCLAMATION 161
#define CENT 162
#define UK_POUND 163
#define YEN 165
#define SECTION 167
#define INT_CURRENCY 168
#define COPYRIGHT 169
#define FEM_ORDINAL 170
#define ANG_QUOTE_LEFT 171

#define DEGREE 176
#define PLUS_MINUS 177
#define SUPERSCRIPT_TWO 178
#define SUPERSCRIPT_THREE 179
#define MU 181
#define PARAGRAPH 182
#define MIDDLE_DOT 183
#define SUPERSCRIPT_ONE 185
#define MASC_ORDINAL 186
#define ANG_QUOTE_RIGHT 187
#define ONE_QUARTER 188
#define ONE_HALF 189
#define INVERTED_QUESTION 191

#define CAPA_GRAVE 192
#define CAPA_ACUTE 193
#define CAPA_CIRCUMFLEX 194
#define CAPA_TILDE 195
#define CAPA_UMLAUT 196
#define CAPA_RING 197
#define CAPAE_LIGATURE 198
#define CAPC_CEDILLA 199
#define CAPE_GRAVE 200
#define CAPE_ACUTE 201
#define CAPE_CIRCUMFLEX 202
#define CAPE_UMLAUT 203
#define CAPI_GRAVE 204
#define CAPI_ACUTE 205
#define CAPI_CIRCUMFLEX 206
#define CAPI_UMLAUT 207

#define CAPN_TILDE 209
#define CAPO_GRAVE 210
#define CAPO_ACUTE 211
#define CAPO_CIRCUMFLEX 212
#define CAPO_TILDE 213
#define CAPO_UMLAUT 214
#define CAPOE_LIGATURE 215
#define CAPO_SLASH 216
#define CAPU_GRAVE 217
#define CAPU_ACUTE 218
#define CAPU_CIRCUMFLEX 219
#define CAPU_UMLAUT 220
#define CAPY_UMLAUT 221
#define GERMAN_SHARP_S 223

#define SMALLA_GRAVE 224
#define SMALLA_ACUTE 225
#define SMALLA_CIRCUMFLEX 226
#define SMALLA_TILDE 227
#define SMALLA_UMLAUT 228
#define SMALLA_RING 229
#define SMALLAE_LIGATURE 230
#define SMALLC_CEDILLA 231
#define SMALLE_GRAVE 232
#define SMALLE_ACUTE 233
#define SMALLE_CIRCUMFLEX 234
#define SMALLE_UMLAUT 235
#define SMALLI_GRAVE 236
#define SMALLI_ACUTE 237
#define SMALLI_CIRCUMFLEX 238
#define SMALLI_UMLAUT 239

#define SMALLN_TILDE 241
#define SMALLO_GRAVE 242
#define SMALLO_ACUTE 243
#define SMALLO_CIRCUMFLEX 244
#define SMALLO_TILDE 245
#define SMALLO_UMLAUT 246
#define SMALLOE_LIGATURE 247
#define SMALLO_SLASH 248
#define SMALLU_GRAVE 249
#define SMALLU_ACUTE 250
#define SMALLU_CIRCUMFLEX 251
#define SMALLU_UMLAUT 252
#define SMALLY_UMLAUT 253

#endif

#define NIL compose_nil

/*****************************************************************************/
/*   c o m p o s e   s e q u e n c e   t r a n s l a t i o n   t a b l e     */
/*****************************************************************************/

static char compose_nil [1] = { 
	0 };

static char compose_space [6*2+1] = { 
	6,
	/*   */  '*',DEGREE, '~','~', '`','`', 39,39, '^','^', '"','"' };

static char compose_exclamation [5*2+1] = { 
	5,
	/* ! */  'S',SECTION, 'P',PARAGRAPH, '!',INVERTED_EXCLAMATION,
	's',SECTION, 'p',PARAGRAPH };

static char compose_quote [13*2+1] = { 
	13,
	/* " */  'A',CAPA_UMLAUT,   'E',CAPE_UMLAUT,   'I',CAPI_UMLAUT,
	'a',SMALLA_UMLAUT, 'e',SMALLE_UMLAUT, 'i',SMALLI_UMLAUT, 
	'O',CAPO_UMLAUT,   'U',CAPU_UMLAUT,   'Y',CAPY_UMLAUT, 
	'o',SMALLO_UMLAUT, 'u',SMALLU_UMLAUT, 'y',SMALLY_UMLAUT, ' ','"' };

/* # */  
/* $ */
/* & */

static char compose_apostrophe [11*2+1] = { 
	11,
	/* ' */  ' ',39,
	'A',CAPA_ACUTE,   'E',CAPE_ACUTE,   'I',CAPI_ACUTE,
	'a',SMALLA_ACUTE, 'e',SMALLE_ACUTE, 'i',SMALLI_ACUTE,
	'O',CAPO_ACUTE,   'U',CAPU_ACUTE,   
	'o',SMALLO_ACUTE, 'u',SMALLU_ACUTE };

static char compose_left_paren [2*2+1] = { 
	2,
	/* ( */  '(','[', '-','{' };

static char compose_right_paren [2*2+1] = { 
	2,
	/* ) */  ')',']', '-','}' };

static char compose_asterisk [3*2+1] = { 
	3,
	/* * */  ' ',DEGREE, 'A',CAPA_RING, 'a',SMALLA_RING };

static char compose_plus [2*2+1] = { 
	2,
	/* + */  '+','#', '-',PLUS_MINUS };

static char compose_comma [2*2+1] = { 
	2,
	/* , */  'C',CAPC_CEDILLA, 'c',SMALLC_CEDILLA };

static char compose_minus [7*2+1] = { 
	7,
	/* - */  'L',UK_POUND, 'l',UK_POUND, 'y',YEN, 'Y',YEN, '+',PLUS_MINUS,
	')','}', '(','{' };

static char compose_period [1*2+1] = { 
	1,
	/* . */  '^',MIDDLE_DOT };

static char compose_slash [9*2+1] = { 
	9,
	/* / */  '<','\\', '/','\\', '^','|', 'c',CENT, 'C',CENT, 'u',MU, 'U',MU,
	'O',CAPO_SLASH, 'o',SMALLO_SLASH };

/*****************************************************************************/

static char compose_0 [7*2+1] = { 
	7,
	/* 0 */  'S',SECTION, 's',SECTION, 'X',INT_CURRENCY, 'x',INT_CURRENCY,
	'C',COPYRIGHT, 'c',COPYRIGHT, '^',DEGREE };

static char compose_1 [3*2+1] = { 
	3,
	/* 1 */  '^',SUPERSCRIPT_ONE, '4',ONE_QUARTER, '2',ONE_HALF };

static char compose_2 [1*2+1] = { 
	1,
	/* 2 */  '^',SUPERSCRIPT_TWO };

static char compose_3 [1*2+1] = { 
	1,
	/* 3 */  '^',SUPERSCRIPT_THREE };

/* 4 */
/* 5 */
/* 6 */
/* 7 */
/* 8 */
/* 9 */
/* : */
/* ; */

static char compose_less_than [2*2+1] = { 
	2,
	/* < */  '<',ANG_QUOTE_LEFT, '/','\\' };

static char compose_equals [4*2+1] = { 
	4,
	/* = */  'L',UK_POUND, 'l',UK_POUND, 'y',YEN, 'Y',YEN };

static char compose_greater_than [1*2+1] = { 
	1,
	/* > */  '>',ANG_QUOTE_RIGHT };

static char compose_question [1*2+1] = { 
	1,
	/* ? */  '?',INVERTED_QUESTION };

/*****************************************************************************/

/* @ */

static char compose_capa [10*2+1] = { 
	10,
	/* A */  'a','@', 'A','@', '_',FEM_ORDINAL, 'E',CAPAE_LIGATURE,
	'`',CAPA_GRAVE,  39,CAPA_ACUTE,  '^',CAPA_CIRCUMFLEX,
	'~',CAPA_TILDE, '"',CAPA_UMLAUT, '*',CAPA_RING };

/* B */

static char compose_capc [6*2+1] = { 
	6,
	/* C */  '0',COPYRIGHT, 'o',COPYRIGHT, 'O',COPYRIGHT, '/',CENT, 
	'|',CENT,  ',',CAPC_CEDILLA };

/* D */

static char compose_cape [4*2+1] = { 
	4,
	/* E */  '`',CAPE_GRAVE,  39,CAPE_ACUTE,  '^',CAPE_CIRCUMFLEX,
	'"',CAPE_UMLAUT };

/* F */
/* G */
/* H */

static char compose_capi [4*2+1] = { 
	4,
	/* I */  '`',CAPI_GRAVE,  39,CAPI_ACUTE,  '^',CAPI_CIRCUMFLEX,
	'"',CAPI_UMLAUT };

/* J */
/* K */

static char compose_capl [2*2+1] = { 
	2,
	/* L */  '-',UK_POUND, '=',UK_POUND };

/* M */

static char compose_capn [1*2+1] = { 
	1,
	/* N */  '~',CAPN_TILDE };

static char compose_capo [14*2+1] = { 
	14,
	/* O */  'S',SECTION, 's',SECTION, 'X',INT_CURRENCY, 'x',INT_CURRENCY,
	'C',COPYRIGHT, 'c',COPYRIGHT, '_',MASC_ORDINAL, 'E',CAPOE_LIGATURE,
	'/',CAPO_SLASH,
	'`',CAPO_GRAVE,  39,CAPO_ACUTE,  '^',CAPO_CIRCUMFLEX,
	'~',CAPO_TILDE, '"',CAPO_UMLAUT }; 

/*****************************************************************************/

static char compose_capp [1*2+1] = { 
	1,
	/* P */  '!',PARAGRAPH };

/* Q */
/* R */

static char compose_caps [4*2+1] = { 
	4,
	/* S */  '0',SECTION, 'O',SECTION, 'o',SECTION, '!',SECTION };

/* T */

static char compose_capu [4*2+1] = { 
	4,
	/* U */  '`',CAPU_GRAVE,  39,CAPU_ACUTE,  '^',CAPU_CIRCUMFLEX,
	'"',CAPU_UMLAUT };

/* V */
/* W */

static char compose_capx [3*2+1] = { 
	3,
	/* X */  '0',INT_CURRENCY, 'O',INT_CURRENCY, 'o',INT_CURRENCY };

static char compose_capy [3*2+1] = { 
	3,
	/* Y */  '-',YEN, '=',YEN, '"',CAPY_UMLAUT };

/* Z */
/* [ */
/* \ */
/* ] */

static char compose_circumflex [17*2+1] = { 
	17,
	/* ^ */  '2',SUPERSCRIPT_TWO, '3',SUPERSCRIPT_THREE, '.',MIDDLE_DOT,
	'1',SUPERSCRIPT_ONE, '0',DEGREE, '/','|', ' ','^',
	'A',CAPA_CIRCUMFLEX,   'E',CAPE_CIRCUMFLEX,   'I',CAPI_CIRCUMFLEX,
	'a',SMALLA_CIRCUMFLEX, 'e',SMALLE_CIRCUMFLEX, 'i',SMALLI_CIRCUMFLEX,
	'O',CAPO_CIRCUMFLEX,   'U',CAPU_CIRCUMFLEX,   
	'o',SMALLO_CIRCUMFLEX, 'u',SMALLU_CIRCUMFLEX };

static char compose_underscore [4*2+1] = { 
	4,
	/* _ */  'a',FEM_ORDINAL, 'A',FEM_ORDINAL, 'o',MASC_ORDINAL, 'O',MASC_ORDINAL };

/*****************************************************************************/

static char compose_single_quote [11*2+1] = { 
	11,
	/* ` */  ' ','`',
	'A',CAPA_GRAVE,   'E',CAPE_GRAVE,   'I',CAPI_GRAVE,
	'a',SMALLA_GRAVE, 'e',SMALLE_GRAVE, 'i',SMALLI_GRAVE,
	'O',CAPO_GRAVE,   'U',CAPU_GRAVE,   
	'o',SMALLO_GRAVE, 'u',SMALLU_GRAVE };

static char compose_smalla [10*2+1] = { 
	10,
	/* a */  'a','@', 'A','@', 'e',SMALLAE_LIGATURE, '_',FEM_ORDINAL,
	'`',SMALLA_GRAVE,  39,SMALLA_ACUTE,  '^',SMALLA_CIRCUMFLEX,
	'~',SMALLA_TILDE, '"',SMALLA_UMLAUT, '*',SMALLA_RING };

/* b */

static char compose_smallc [6*2+1] = { 
	6,
	/* c */  '0',COPYRIGHT, 'o',COPYRIGHT, 'O',COPYRIGHT, '/',CENT, 
	'|',CENT, ',',SMALLC_CEDILLA };

/* d */

static char compose_smalle [4*2+1] = { 
	4,
	/* e */  '`',SMALLE_GRAVE,  39,SMALLE_ACUTE,  '^',SMALLE_CIRCUMFLEX,
	'"',SMALLE_UMLAUT };

/* f */
/* g */
/* h */

static char compose_smalli [4*2+1] = { 
	4,
	/* i */  '`',SMALLI_GRAVE,  39,SMALLI_ACUTE,  '^',SMALLI_CIRCUMFLEX,
	'"',SMALLI_UMLAUT };

/* j */
/* k */

static char compose_smalll [2*2+1] = { 
	2,
	/* l */  '-',UK_POUND, '=',UK_POUND };

/* m */

static char compose_smalln [1*2+1] = { 
	1,
	/* n */  '~',SMALLN_TILDE };

static char compose_smallo [14*2+1] = { 
	14,
	/* o */  'S',SECTION, 's',SECTION, 'X',INT_CURRENCY, 'x',INT_CURRENCY,
	'C',COPYRIGHT, 'c',COPYRIGHT, '_',MASC_ORDINAL, 'e',SMALLOE_LIGATURE,
	'/',SMALLO_SLASH,
	'`',SMALLO_GRAVE,  39,SMALLO_ACUTE,  '^',SMALLO_CIRCUMFLEX,
	'~',SMALLO_TILDE, '"',SMALLO_UMLAUT };

/*****************************************************************************/

static char compose_smallp [1*2+1] = { 
	1,
	/* p */  '!',PARAGRAPH };

/* q */
/* r */

static char compose_smalls [5*2+1] = { 
	5,
	/* s */  's',GERMAN_SHARP_S, '0',SECTION, 'O',SECTION, 'o',SECTION, 
	'!',SECTION };

/* t */

static char compose_smallu [4*2+1] = { 
	4,
	/* u */  '`',SMALLU_GRAVE,  39,SMALLU_ACUTE,  '^',SMALLU_CIRCUMFLEX,
	'"',SMALLU_UMLAUT };

/* v */
/* w */

static char compose_smallx [3*2+1] = { 
	3,
	/* x */  '0',INT_CURRENCY, 'O',INT_CURRENCY, 'o',INT_CURRENCY };

static char compose_smally [3*2+1] = { 
	3,
	/* y */  '-',YEN, '=',YEN, '"',SMALLY_UMLAUT };

/* z */
/* { */

static char compose_pipe [2*2+1] = { 
	2,
	/* | */  'c',CENT, 'C',CENT };

/* } */

static char compose_tilde [7*2+1] = { 
	7,
	/* ~ */  ' ','~', 'A',CAPA_TILDE,   'N',CAPN_TILDE,   'O',CAPO_TILDE,
	'a',SMALLA_TILDE, 'n',SMALLN_TILDE, 'o',SMALLO_TILDE };

/* del */


/*****************************************************************************/
/*        c o m p o s e   s e q u e n c e   p o i n t e r   t a b l e        */
/*****************************************************************************/

char *compose_ptr [100] = {

	/*   */  compose_space,
	/* ! */  compose_exclamation,
	/* " */  compose_quote,
	/* # */  NIL,
	/* $ */  NIL,
	/* % */  NIL,
	/* & */  NIL,
	/* ' */  compose_apostrophe,
	/* ( */  compose_left_paren,
	/* ) */  compose_right_paren,
	/* * */  compose_asterisk,
	/* + */  compose_plus,
	/* , */  compose_comma,
	/* - */  compose_minus,
	/* . */  compose_period,
	/* / */  compose_slash,
	/*****************************************************************************/
	/* 0 */  compose_0,
	/* 1 */  compose_1,
	/* 2 */  compose_2,
	/* 3 */  compose_3,
	/* 4 */  NIL,
	/* 5 */  NIL,
	/* 6 */  NIL,
	/* 7 */  NIL,
	/* 8 */  NIL,
	/* 9 */  NIL,
	/* : */  NIL,
	/* ; */  NIL,
	/* < */  compose_less_than,
	/* = */  compose_equals,
	/* > */  compose_greater_than,
	/* ? */  compose_question,
	/*****************************************************************************/
	/* @ */  NIL,
	/* A */  compose_capa,
	/* B */  NIL,
	/* C */  compose_capc,
	/* D */  NIL,
	/* E */  compose_cape,
	/* F */  NIL,
	/* G */  NIL,
	/* H */  NIL,
	/* I */  compose_capi,
	/* J */  NIL,
	/* K */  NIL,
	/* L */  compose_capl,
	/* M */  NIL,
	/* N */  compose_capn,
	/* O */  compose_capo,
	/*****************************************************************************/
	/* P */  compose_capp,
	/* Q */  NIL,
	/* R */  NIL,
	/* S */  compose_caps,
	/* T */  NIL,
	/* U */  compose_capu,
	/* V */  NIL,
	/* W */  NIL,
	/* X */  compose_capx,
	/* Y */  compose_capy,
	/* Z */  NIL,
	/* [ */  NIL,
	/* \ */  NIL,
	/* ] */  NIL,
	/* ^ */  compose_circumflex,
	/* _ */  compose_underscore,
	/*****************************************************************************/
	/* ` */  compose_single_quote,
	/* a */  compose_smalla,
	/* b */  NIL,
	/* c */  compose_smallc,
	/* d */  NIL,
	/* e */  compose_smalle,
	/* f */  NIL,
	/* g */  NIL,
	/* h */  NIL,
	/* i */  compose_smalli,
	/* j */  NIL,
	/* k */  NIL,
	/* l */  compose_smalll,
	/* m */  NIL,
	/* n */  compose_smalln,
	/* o */  compose_smallo,
	/*****************************************************************************/
	/* p */  compose_smallp,
	/* q */  NIL,
	/* r */  NIL,
	/* s */  compose_smalls,
	/* t */  NIL,
	/* u */  compose_smallu,
	/* v */  NIL,
	/* w */  NIL,
	/* x */  compose_smallx,
	/* y */  compose_smally,
	/* z */  NIL,
	/* { */  NIL,
	/* | */  compose_pipe,
	/* } */  NIL,
	/* ~ */  compose_tilde,
	/* del */  NIL };

