PROJ = pmenv
PROJFILE = pmenv.mak
DEBUG = 0

PWBRMAKE  = pwbrmake
NMAKEBSC1  = set
NMAKEBSC2  = nmake
BRFLAGS  =  /o $(PROJ).bsc
BROWSE  = 0
LINKER  = link
ILINK  = ilink
LRF  = echo > NUL
BIND  = bind
RC  = rc
IMPLIB  = implib
LFLAGS_G  = /STACK:8192 /NOI /BATCH
LFLAGS_D  = /CO /INC /FAR /PACKC /PACKD /PMTYPE:PM
LFLAGS_R  = /EXE /FAR /PACKC /PACKD /PMTYPE:PM
MAPFILE_D  = NUL
MAPFILE_R  = NUL
CC  = cl
CFLAGS_G  = /AL /W4 /G2 /D_MT /Zp /MT /BATCH
CFLAGS_D  = /Od /Zi /Gi$(PROJ).mdt /Gs
CFLAGS_R  = /Ot /Oi /Ol /Oe /Og /Gs
LLIBS_R  =  /NOD:LLIBCE LLIBCMT
LLIBS_D  =  /NOD:LLIBCE LLIBCMT
ASM  = masm
AFLAGS_G  = /Mx /T
AFLAGS_D  = /Zi

OBJS  = pmenv.obj printsup.obj dlgsup.obj help.obj
RESS  = pmenv.res
SBRS  = pmenv.sbr printsup.sbr dlgsup.sbr help.sbr

all: $(PROJ).exe

.SUFFIXES: .c .sbr .rc .res .obj

pmenv.obj : pmenv.c d:\include\io.h d:\include\malloc.h d:\include\process.h\
        d:\include\stddef.h d:\include\stdio.h d:\include\stdlib.h\
        d:\include\string.h d:\include\os2.h pmenv.h d:\include\os2def.h\
        d:\include\bse.h d:\include\pm.h d:\include\bsedos.h\
        d:\include\bsesub.h d:\include\bseerr.h d:\include\bsedev.h\
        d:\include\pmwin.h d:\include\pmgpi.h d:\include\pmdev.h\
        d:\include\pmavio.h d:\include\pmpic.h d:\include\pmord.h\
        d:\include\pmbitmap.h d:\include\pmfont.h d:\include\pmtypes.h\
        d:\include\pmmle.h d:\include\pmshl.h d:\include\pmerr.h\
        d:\include\pmhelp.h

pmenv.sbr : pmenv.c d:\include\io.h d:\include\malloc.h d:\include\process.h\
        d:\include\stddef.h d:\include\stdio.h d:\include\stdlib.h\
        d:\include\string.h d:\include\os2.h pmenv.h d:\include\os2def.h\
        d:\include\bse.h d:\include\pm.h d:\include\bsedos.h\
        d:\include\bsesub.h d:\include\bseerr.h d:\include\bsedev.h\
        d:\include\pmwin.h d:\include\pmgpi.h d:\include\pmdev.h\
        d:\include\pmavio.h d:\include\pmpic.h d:\include\pmord.h\
        d:\include\pmbitmap.h d:\include\pmfont.h d:\include\pmtypes.h\
        d:\include\pmmle.h d:\include\pmshl.h d:\include\pmerr.h\
        d:\include\pmhelp.h

pmenv.res : pmenv.rc d:\include\os2.h pmenv.h envelope.dlg help.rc\
        d:\include\os2def.h d:\include\bse.h d:\include\pm.h\
        d:\include\bsedos.h d:\include\bsesub.h d:\include\bseerr.h\
        d:\include\bsedev.h d:\include\pmwin.h d:\include\pmgpi.h\
        d:\include\pmdev.h d:\include\pmavio.h d:\include\pmpic.h\
        d:\include\pmord.h d:\include\pmbitmap.h d:\include\pmfont.h\
        d:\include\pmtypes.h d:\include\pmmle.h d:\include\pmshl.h\
        d:\include\pmerr.h d:\include\pmhelp.h

printsup.obj : printsup.c

printsup.sbr : printsup.c

dlgsup.obj : dlgsup.c

dlgsup.sbr : dlgsup.c

help.obj : help.c

help.sbr : help.c


$(PROJ).bsc : $(SBRS)
        $(PWBRMAKE) @<<
$(BRFLAGS) $(SBRS)
<<

$(PROJ).exe : $(OBJS) $(RESS)
!IF $(DEBUG)
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
!IF $(DEBUG)
        $(ILINK) -a -e "$(LINKER) @$(PROJ).lrf" $@
!ELSE
        $(LINKER) @$(PROJ).lrf
!ENDIF
        $(RC) $(RESS) $@


.c.sbr :
!IF $(DEBUG)
        $(CC) /Zs $(CFLAGS_G) $(CFLAGS_D) /FR$@ $<
!ELSE
        $(CC) /Zs $(CFLAGS_G) $(CFLAGS_R) /FR$@ $<
!ENDIF

.rc.res :
        $(RC) /r $< $@

.c.obj :
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF


run: $(PROJ).exe
        $(PROJ).exe $(RUNFLAGS)

debug: $(PROJ).exe
        CVP $(CVFLAGS) $(PROJ).exe $(RUNFLAGS)
