:userdoc.
:title.PM File View Help Facility
.*
:docprof.
.*
.* ----------------------------------------------------------------------
.* Extended Help
:h1 res=30002.Help for PM File View
:i1 id=fvhelp.Help for PM File View
:hp1.PM File View:ehp1. is a file browsing utility for the OS/2
Presentation Manager.  It
displays files either in ASCII or in hex (see
:link res=42 reftype=hd.Display ASCII:elink.,
:link res=43 reftype=hd.Display Hex-ASCII:elink., and
:link res=44 reftype=hd.Display Hex-EBCDIC:elink.),
and additionally permits
searching by phrase or jumping directly to a specified point in a
file (see
:link res=30 reftype=hd.Find:elink.,
:link res=31 reftype=hd.Repeat Find:elink., and
:link res=32 reftype=hd.Goto:elink.).
:p.
:hp1.PM File View:ehp1. can be invoked either from an OS/2 window or from
the full-screen command line.  If no filename is entered initially, or
the filename contains wildcards,
a dialog box is opened listing the available drives and files from
which a file may be selected (see
:link res=10 reftype=hd.Open:elink.).
:hp1.PM File View:ehp1. can also be made
a part of a Desktop Manager group, in which case it can be selected from
a menu.  Adding the optional /i switch, either at the
command line or as a parameter of the Program Properties menu, will
load :hp1.PM File View:ehp1. with a specified filename and immediately
shrink it to an icon at start-up, making the file information instantly
available with the double-click of the mouse on the icon (see
:link res=31001 reftype=hd.Command Line Options:elink.).
:p.
The selected
filename is shown in the title bar of the display window and as the title
of an icon when the window is minimized.  A status line containing the
file position (line number
or byte offset) can optionally also be displayed at the bottom of the
display window (see
:link res=45 reftype=hd.File Position:elink.).
:p.
Search menu options for :hp1.PM File View:ehp1. permit entering either a
phrase or an offset to which the utility will jump.
:link res=41 reftype=hd.Configuration:elink.
options
permit customizing the screen color, display font size, display format,
tab stop setting, and whether or not the scroll bars and/or the file
position status line should be shown (see also
:link res=47 reftype=hd.Font Size:elink.).
These settings become program defaults, but may be changed at any time.
:p.
.*
.* ----------------------------------------------------------------------
:h2 res=30003.Keys Help
:i2 refid=fvhelp.Keys
:parml.
:pt.:hp2.F1:ehp2.
:pd.
Displays Help for Show Picture.
:pt.:hp2.Esc:ehp2.
:pd.
Displays the Open File dialog box if a dialog box is not displayed.
Cancels (removes) a file dialog box if one is displayed.
(see :hp2.File :ehp2.:link res=10 reftype=hd.Open:elink.)
:eparml.
:p.
:p.
The following keys may be used only when there are no dialog boxes
displayed:
:parml.
:pt.:hp2.F3:ehp2.
:pd.
Terminates :hp1.PM File View:ehp1..
(see :hp2.File :ehp2.:link res=12 reftype=hd.Exit:elink.)
:pt.:hp2.Ctrl-N:ehp2.
:pd.
Closes the current file being displayed, and brings up the Open File
dialog box for selection of another file.
(see :hp2.File :ehp2.:link res=11 reftype=hd.New:elink.)
:pt.:hp2.Ctrl-O:ehp2.
:pd.
Displays the Open File dialog box.
(see :hp2.File :ehp2.:link res=10 reftype=hd.Open:elink.)
:pt.:hp2.Ctrl-F:ehp2.
:pd.
Displays the Find dialog box for entry of search parameters, and then
searches the file for the specified text or hex string.
(see :hp2.Search :ehp2.:link res=30 reftype=hd.Find:elink.)
:pt.:hp2.Ctrl-R:ehp2.
:pd.
Repeats the last Find.
(see :hp2.Search :ehp2.:link res=31 reftype=hd.Repeat Find:elink.)
:pt.:hp2.Ctrl-G:ehp2.
:pd.
Displays the Goto dialog box for entry of a file offset, and then
positions the file offset line at the top of the display window.
(see :hp2.Search :ehp2.:link res=32 reftype=hd.Goto:elink.)
:pt.:hp2.Ctrl-C:ehp2.
:pd.
Displays a dialog box for configuring the display appearance.
(see :hp2.Display :ehp2.:link res=41 reftype=hd.Configure:elink.)
:pt.:hp2.Ctrl-A:ehp2.
:pd.
Displays the file in ASCII format.
(see :link res=42 reftype=hd.Display ASCII:elink.)
:pt.:hp2.Ctrl-H:ehp2.
:pd.
Displays the file in Hexadecimal - ASCII format.
(see :link res=43 reftype=hd.Display Hex-ASCII:elink.)
:pt.:hp2.Ctrl-E:ehp2.
:pd.
Displays the file in Hexadecimal - EBCDIC format.
(see :link res=44 reftype=hd.Display Hex-EBCDIC:elink.)
:pt.:hp2.Ctrl-P:ehp2.
:pd.
Toggles the inclusion / exclusion of a file position status line in the
display window.
(see :hp2.Display :ehp2.:link res=45 reftype=hd.File Position:elink.)
:pt.:hp2.Ctrl-B:ehp2.
:pd.
Toggles the inclusion / exclusion of scroll bars in the display
window.
(see :hp2.Display :ehp2.:link res=46 reftype=hd.Scroll Bars:elink.)
:pt.:hp2.Ctrl-S:ehp2.
:pd.
Depending on the display, either toggles the font size (between large and
small) or displays a dialog box for selecting a font size.
(see :hp2.Display :ehp2.:link res=44 reftype=hd.Font Size:elink.)
:pt.:hp2.&darrow.:ehp2.
:pd.
Moves the display window down one line in the file.
:pt.:hp2.&uarrow.:ehp2.
:pd.
Moves the display window up one line in the file.
:pt.:hp2.&bxh.&rarrow.:ehp2.
:pd.
Moves the display window one character to the right.
:pt.:hp2.&larrow.&bxh.:ehp2.
:pd.
Moves the display window one character to the left.
:pt.:hp2.Page Down:ehp2.
:pd.
Moves the display window down one screen in the file.
:pt.:hp2.Page Up:ehp2.
:pd.
Moves the display window up one screen in the file.
:pt.:hp2.Home:ehp2.
:pd.
Moves the display window to the top of the file.
:pt.:hp2.End:ehp2.
:pd.
Moves the display window to the end of the file.
:eparml.
.* ----------------------------------------------------------------------
:h2 res=10.Open
:i2 refid=fvhelp.Open
Use :hp2.File Open...:ehp2. to select a file to be
displayed.
:p.
This selection will open a dialog box, from which a file can be selected
or specified in the entry box of the dialog.  Wildcards specified in the
entry box will filter the list of filenames displayed in the dialog box.
:p.
Shortcut keys: :hp2.Ctrl-O:ehp2., :hp2.Esc:ehp2.
.* ----------------------------------------------------------------------
:h2 res=11.New
:i2 refid=fvhelp.New
Use :hp2.File New...:ehp2. to close the current file and display an Open
File dialog box.  As :hp1.PM File View:ehp1. does not allow other
applications to write to the file being displayed,
this selection is useful when it is needed to make the currently
displayed file available to other programs for writing without exiting
:hp1.PM File View:ehp1. or opening another file.
:p.
Shortcut key: :hp2.Ctrl-N:ehp2.
.* ----------------------------------------------------------------------
:h2 res=12.Exit
:i2 refid=fvhelp.Exit
Selection of :hp2.File Exit:ehp2. will terminate
:hp1.PM File View:ehp1..
:p.
Shortcut key: :hp2.F3:ehp2.
:p.
(The shortcut key cannot be used when a
dialog box is displayed)
.* ----------------------------------------------------------------------
:h2 res=30.Find
:i2 refid=fvhelp.Find
Use :hp2.Search Find...:ehp2. to locate a text or hexadecimal string
in the displayed file.  The line containing the string becomes the top
line in the display window.
:p.
Use the Find dialog box to enter the string to be located.
The string entered is assumed to be ASCII text
unless the :hp2.Hex String:ehp2. box is checked.  If it is desired to
find the ASCII text exactly as entered in the dialog box, check the
:hp2.Case Sensitive:ehp2. box; otherwise, the upper / lower case of
characters in the search string and the file will be ignored in their
comparison, e.g. an :hp2.a:ehp2. will match an :hp2.A:ehp2..
:p.
Hexadecimal strings may be entered with or without spaces between bytes
and with upper and/or lower case hexadecimal digits.
For example,
:xmp.
6FAC880D
:exmp.
:p.
can also be entered as
:xmp.
6f Ac 88 0d
:exmp.
:p.
However, be aware that the hexadecimal string entry
:xmp.
6 f a c 8 8 0 d
:exmp.
:p.
will be treated as
:xmp.
060f0a0c0808000d
:exmp.
:p.
The search will start from the current file position (the top line
in the display window) unless the :hp2.Search from Top:ehp2. box is
checked, in which case the search is started from the beginning of
the file.
:p.
Shortcut key: :hp2.Ctrl-F:ehp2.
.* ----------------------------------------------------------------------
:h2 res=31.Repeat Find
:i2 refid=fvhelp.Repeat Find
Use :hp2.Search Repeat Find:ehp2. to find the next occurrence of the last
string entered in the Find dialog box.  Note that if the
:hp2.Search from Top:ehp2. box was checked when the last Find was
executed, repeated use of the :hp2.Repeat Find:ehp2. selection will
always go to the same point in the file -- the first occurrence of the
search string in the file.  In other words, the :hp2.Repeat Find:ehp2.
command is most useful when the :hp2.Search from Top:ehp2. box in the
Find dialog box is not checked.
:p.
Shortcut key: :hp2.Ctrl-R:ehp2.
.* ----------------------------------------------------------------------
:h2 res=32.Goto
:i2 refid=fvhelp.Goto
Use :hp2.Search Goto...:ehp2. to move the display window to a specified
offset position in the file.  The offset position and type of offset are
entered in a Goto dialog box when the :hp2.Goto...:ehp2. selection is
invoked.  If a byte offset is specified, the character in the file at
the offset position is displayed at the top row and leftmost column of the
display window; an offset of zero corresponds to the first character
(byte) in the file.  If the offset is a line number, n, then the nth
line in the file is displayed as top line in the display window (the
first line in the file is line number 1).
:p.
To specify a byte offset, enter the offset in the dialog box and click
on the either the :hp2.Decimal:ehp2. button if the offset is a decimal
number, or the :hp2.Hexadecimal:ehp2. button if the offset is a
hexadecimal value.  A line offset is specified by typing the line
number in the dialog box entry field and clicking on the
:hp2.Line No.:ehp2. button.
:p.
The actual positioning of the file to the specified offset occurs when
the :hp2.Goto:ehp2. button is clicked or the :hp2.Enter:ehp2. key is
pressed.  Clicking on the :hp2.Cancel:ehp2. button or pressing the
:hp2.Esc:ehp2. key terminates the Goto dialog without performing any file
positioning.
:p.
Shortcut key: :hp2.Ctrl-G:ehp2.
.* ----------------------------------------------------------------------
:h2 res=41.Configure
:i2 refid=fvhelp.Configure
Use :hp2.Display Configure...:ehp2. to open a dialog box to
change and save various display
characteristics, including the window text and background colors, font
size, file display mode, number of characters between tab stops,
whether or not scroll bars should be included in the display, and
whether or not a file position status line should be displayed.
:p.
Pressing the :hp2.Enter:ehp2. key or clicking on the :hp2.OK:ehp2.
button will change the display according to the selections in the
dialog box.  If the :hp2.Save values to disk:ehp2. box is checked, the
selections will also be saved to disk.  Then, each time
:hp1.PM File View:ehp1. is started, the saved selections will be invoked.
If the
:hp2.Save window position:ehp2. box is checked, the current size and
position
of the :hp1.PM FIle View:ehp1. window will also be saved and then will
be restored each time the program is started.
:p.
If the :hp2.Cancel:ehp2. button is clicked or the :hp2.Esc:ehp2. key is
pressed, the display is not changed, and the settings are not saved to
disk.
:p.
Shortcut key: :hp2.Ctrl-C:ehp2.
.* ----------------------------------------------------------------------
:h2 res=42.Display ASCII
:i2 refid=fvhelp.Display ASCII
Select the :hp2.Display Display ASCII:ehp2. pull-down menu item to view
the file as characters and symbols.  This is the normal mode to view text
files.  Non-text/ASCII files viewed with this selection will appear as
gibberish and will likely not have meaningful line layouts; use one of
the Hex display modes for these types of files.
(see
:link res=43 reftype=hd.Display Hex-ASCII:elink., and
:link res=44 reftype=hd.Display Hex-EBCDIC:elink.).
:p.
Shortcut key: :hp2.Ctrl-A:ehp2.
.* ----------------------------------------------------------------------
:h2 res=43.Display Hex-ASCII
:i2 refid=fvhelp.Display Hex-ASCII
Select the :hp2.Display Display Hex-ASCII:ehp2. pull-down menu item to
view the file as hexadecimal bytes with their corresponding ASCII
characters and PC symbols.  Each line contains three sections: (1) an
eight-digit byte file offset of the first byte on the line; (2) sixteen
hexadecimal bytes of the file; and (3) the ASCII characters or PC
symbols corresponding to the hexadecimal values.
:p.
This display format is most often used with non-text PC files.  For
text/ASCII and IBM Host files, see
:link res=42 reftype=hd.Display ASCII:elink., and
:link res=44 reftype=hd.Display Hex-EBCDIC:elink..
:p.
Shortcut key: :hp2.Ctrl-H:ehp2.
.* ----------------------------------------------------------------------
:h2 res=44.Display Hex-EBCDIC
:i2 refid=fvhelp.Display Hex-EBCDIC
Select the :hp2.Display Display Hex-EBCDIC:ehp2. pull-down menu item to
view the file as hexadecimal bytes with their corresponding EBCDIC
characters.  Each line contains three sections: (1) an
eight-digit byte file offset of the first byte on the line; (2) sixteen
hexadecimal bytes of the file; and (3) the EBCDIC characters
corresponding to the hexadecimal values.
:p.
This display format is most often used with IBM Host and DisplayWrite
DOC and RFT files.  For text/ASCII and non-text PC files, see
:link res=42 reftype=hd.Display ASCII:elink., and
:link res=44 reftype=hd.Display Hex-ASCII:elink..
:p.
Shortcut key: :hp2.Ctrl-E:ehp2.
.* ----------------------------------------------------------------------
:h2 res=45.File Position
:i2 refid=fvhelp.File Position
Use the :hp2.Display File Position:ehp2. menu item to toggle the
display of the line number or byte offset status line at the bottom of
the display window.  If this item is not checked, selecting it will
display the status line; if this item is checked, selecting it will
remove the line.  Note: Displaying the File Position status line
with :hp2.Display ASCII:ehp2. selected may
slow down response, particularly with large files, as the
lines are counted while loading and moving through the file.
:p.
With
:link res=42 reftype=hd.Display ASCII:elink.
selected, the status line will display the number of the line in the
file currently displayed at the top of the display window, along with
the total number of lines in the file.  The latter number may be one
greater than similar line totals displayed in line editors, as
:hp1.PM File View:ehp1. considers anything after the last line-feed,
including the end-of-file (hex 1A) character, to be another line.
The line number starts with 1.
:p.
With
:link res=43 reftype=hd.Display Hex-ASCII:elink. or
:link res=44 reftype=hd.Display Hex-EBCDIC:elink.
selected, the status line will display in decimal format the offset
into the file of the first byte displayed on the top line of the
display window.  Thus the first byte of the file is numbered 0.  Also
displayed on the status line, in both decimal and hexadecimal formats,
is the offset number of the last byte in the file.  Therefore, this latter
number is one less than the number of bytes in the file.
:p.
Shortcut key: :hp2.Ctrl-P:ehp2.
.* ----------------------------------------------------------------------
:h2 res=46.Scroll Bars
:i2 refid=fvhelp.Scroll Bars
Use the :hp2.Display Scroll Bars:ehp2. pull-down menu item to remove the
the scroll bars from the :hp1.PM File View:ehp1.
window if they are displayed, or to add scroll bars if they are not
present.
:p.
Removing the scroll bars will allow more of the file to be displayed,
but the keyboard (arrow, page, :hp2.Home:ehp2. and :hp2.End:ehp2. keys)
must then be used to move through the file.
:p.
Shortcut key: :hp2.Ctrl-B:ehp2.
.* ----------------------------------------------------------------------
:h2 res=47.Font Size
:i2 refid=fvhelp.Font Size
Use the font size pull-down menu item to change the font used to display
the file.  This selection item will appear in the menu in different
forms, depending on the type of display:
:parml.
:pt.:hp2.CGA:ehp2.
:pd.
For a CGA screen, this item will be disabled, as only one size font can
be displayed with that adapter.
:pt.:hp2.EGA:ehp2. and :hp2.VGA:ehp2.
:pd.
For EGA and VGA screens, this menu item will be :hp2.Small Font:ehp2. if
the file is currently being displayed in the large font, or will be
:hp2.Large Font:ehp2. if the file is being displayed in the small font.
Thus, selecting this item will change the display from large font to
small font, and vice versa.
:pt.:hp2.8514/A:ehp2. and :hp2.XGA:ehp2.
:pd.
For 8514 and XGA screens, this menu item will appear as
:hp2.Font Size...:ehp2..  Selection of this item will then bring up the
Font Size list box / dialog window, from which a font can be selected.
:eparml.
:p.
The :hp2.Display :ehp2.
:link res=41 reftype=hd.Configure...:elink.
menu item can also be used to set the font size for any display.
:p.
Shortcut key: :hp2.Ctrl-S:ehp2.
.* ----------------------------------------------------------------------
:h2 res=31001.Command Line Options
:i2 refid=fvhelp.Command Line Options
:hp1.PM File View:ehp1. is invoked with the following syntax
(the parameters :hp2.must:ehp2. be separated by at least one space):
:p.
:hp2.PMVIEW:ehp2.
[filename.ext]
[:hp2./i:ehp2.]
[:hp2./M:ehp2.]
:p.
where:
:parml.
:pt.filename.ext
:pd.
optionally is the name of a file to be
displayed.  If a filename.ext is not given
or contains wildcards,
:hp1.PM File View:ehp1. displays the Open File dialog box on start-up.
If wildcards are included in the filename.ext, only files which meet
the wildcard criteria are listed in the dialog box.
:pt.:hp2./i:ehp2.
:pd.
is an optional parameter which causes
:hp1.PM File View:ehp1. to start up as an icon.
Note that filename.ext must be given
when this option is used.
:pt.:hp2./M:ehp2.
:pd.
is an optional parameter which causes the Minimize button to be
:hp2.excluded:ehp2. from the frame window.  This option is used only
in special circumstances where it is necessary to prevent the inadvertent
use of the Minimize button as a "Close" button.
:eparml.
:p.
.* ----------------------------------------------------------------------
:euserdoc.

