/** REXX **************************************************************/
/*                                                                    */
/*  Function Name:  REXTEST2                                          */
/*                                                                    */
/*  Description:    Tests the REXXUTIL Macrospace functions           */
/*                                                                    */
/*  Author:         W. David Ashley                                   */
/*                                                                    */
/*  Version:        1.0                                               */
/*                                                                    */
/*  Invocation:     rextest2 rext.rxl                                 */
/*                                                                    */
/*                                                                    */
/**********************************************************************/

/* Make REXXUTIL.DLL library functions available */
if rxfuncquery('RexMacroLoad') = 1 then ,
 call rxfuncadd 'RexMacroLoad', 'REXXUTIL', 'RexMacroLoad'
if rxfuncquery('RexMacroQuery') = 1 then ,
 call rxfuncadd 'RexMacroQuery', 'REXXUTIL', 'RexMacroQuery'
if rxfuncquery('RexMacroDrop') = 1 then ,
 call rxfuncadd 'RexMacroDrop', 'REXXUTIL', 'RexMacroDrop'

/* Check to see if functions are loaded */
if RexMacroQuery('Rext1') <> 0 &,
 RexMacroQuery('Rext2') <> 0 &,
 RexMacroQuery('Rext3') <> 0 &,
 RexMacroQuery('Rext4') <> 0 then,
 call RexMacroLoad arg(1)

/* call functions */
call rext1
call rext2
call rext3
call rext4

/* drop functions */
call RexMacroDrop 'rext1'
call RexMacroDrop 'rext2'
call RexMacroDrop 'rext3'
call RexMacroDrop 'rext4'

/* exit function */
return
