/*** Rexx Cmd for Testing RexxUtil DLL functions - By David Ashley ***/
/*** Test Cmd for RexxUtil Version 2.00 (Vio functions)            ***/
trace 'o'
arg opt


if opt='DELETE' then do   /* Used to drop functions */
  call drop_func
  say 'Functions dropped.'
  exit
  end


/*** Add each desired function or it won't work ***/
call RxFuncAdd 'RexCls',          'REXXUTIL', 'REXCLS'
call RxFuncAdd 'RexGetKey',       'REXXUTIL', 'REXGETKEY'
call RxFuncAdd 'RexPause',        'REXXUTIL', 'REXPAUSE'
call RxFuncAdd 'RexUtilVersion',  'REXXUTIL', 'REXUTILVERSION'
call RxFuncAdd 'RexVioScrollDn',  'REXXUTIL', 'REXVIOSCROLLDN'
call RxFuncAdd 'RexVioScrollLf',  'REXXUTIL', 'REXVIOSCROLLLF'
call RxFuncAdd 'RexVioScrollRt',  'REXXUTIL', 'REXVIOSCROLLRT'
call RxFuncAdd 'RexVioScrollUp',  'REXXUTIL', 'REXVIOSCROLLUP'
call RxFuncAdd 'RexVioSetCurPos', 'REXXUTIL', 'REXVIOSETCURPOS'
call RxFuncAdd 'RexVioGetMode',   'REXXUTIL', 'REXVIOGETMODE'
call RxFuncAdd 'RexVioWrtTTY',    'REXXUTIL', 'REXVIOWRTTTY'
call RxFuncAdd 'RexVioWrtNChar',  'REXXUTIL', 'REXVIOWRTNCHAR'
call RxFuncAdd 'RexVioWrtNAttr',  'REXXUTIL', 'REXVIOWRTNATTR'
call RxFuncAdd 'RexVioWrtCharStr','REXXUTIL', 'REXVIOWRTCHARSTR'
say; say 'Functions have now been loaded.'


/*** Give greetings ***/
call RexCls
say 'This is a test exec for RexxUtil Version 'RexUtilVersion()'!'
call RexPause


/*** Get screen mode settings ***/
call RexCls
mode = RexVioGetMode()
parse var mode type colors cols rows hres vres
say 'The screen type is' type
say 'The number of colors is' colors
say 'The number of columns is' cols
say 'The number of rows is' rows
say 'The horizontal resolution is' hres
say 'The vertical resolution is' vres
call RexPause


/*** Fill screen with characters ***/
call RexCls
call RexVioWrtNChar 'A', cols*(rows-2), 0, 0
call RexVioWrtCharStr copies(' ', cols), rows-2, 0
call RexVioWrtCharStr "Screen filled with 'A' characters.", rows-2, 0
call RexVioWrtCharStr copies(' ', cols), rows-1, 0
call RexVioSetCurPos rows-1, 0
call RexVioWrtTTY 'Press any key to continue...'
key = RexGetKey()


/*** Change the attribute ***/
call RexVioWrtNAttr x2c('72'), cols*(rows-2), 0, 0
call RexVioWrtCharStr copies(' ', cols), rows-2, 0
call RexVioWrtCharStr "Attributes changed to green on white.", rows-2, 0
call RexVioSetCurPos rows-1, 0
call RexVioWrtTTY 'Press any key to continue...'
key = RexGetKey()


/*** Scroll up ***/
fill = 'B' || x2c('72')
call RexVioScrollUp 0, 0, rows-3, cols, 4, fill
call RexVioWrtCharStr copies(' ', cols), rows-2, 0
call RexVioWrtCharStr "Screen scrolled up 4 lines with 'B' fill.", rows-2, 0
call RexVioSetCurPos rows-1, 0
call RexVioWrtTTY 'Press any key to continue...'
key = RexGetKey()


/*** Scroll down ***/
fill = 'C' || x2c('72')
call RexVioScrollDn 0, 0, rows-3, cols, 2, fill
call RexVioWrtCharStr copies(' ', cols), rows-2, 0
call RexVioWrtCharStr "Screen scrolled down 2 lines with 'C' fill.", rows-2, 0
call RexVioSetCurPos rows-1, 0
call RexVioWrtTTY 'Press any key to continue...'
key = RexGetKey()


/*** Scroll left ***/
fill = 'D' || x2c('72')
call RexVioScrollLf 0, 0, rows-3, cols, 10, fill
call RexVioWrtCharStr copies(' ', cols), rows-2, 0
call RexVioWrtCharStr "Screen scrolled down 10 cols with 'D' fill.", rows-2, 0
call RexVioSetCurPos rows-1, 0
call RexVioWrtTTY 'Press any key to continue...'
key = RexGetKey()


/*** Scroll right ***/
fill = 'E' || x2c('72')
call RexVioScrollRt 0, 0, rows-3, cols, 5, fill
call RexVioWrtCharStr copies(' ', cols), rows-2, 0
call RexVioWrtCharStr "Screen scrolled down 5 cols with 'E' fill.", rows-2, 0
call RexVioSetCurPos rows-1, 0
call RexVioWrtTTY 'Press any key to continue...'
key = RexGetKey()


/*** Give Salutations ***/
call RexCls
call drop_func
say; say 'Bye'
exit


drop_func:
/**** Drop all used functions ****/
call RxFuncDrop('RexCls')
call RxFuncDrop('RexGetKey')
call RxFuncDrop('RexPause')
call RxFuncDrop('RexUtilVersion')
call RxFuncDrop('RexVioScrollDn')
call RxFuncDrop('RexVioScrollLf')
call RxFuncDrop('RexVioScrollRt')
call RxFuncDrop('RexVioScrollUp')
call RxFuncDrop('RexVioSetCurPos')
call RxFuncDrop('RexVioGetMode')
call RxFuncDrop('RexVioWrtTTY')
call RxFuncDrop('RexVioWrtNChar')
call RxFuncDrop('RexVioWrtNAttr')
call RxFuncDrop('RexVioWrtCharStr')
return

