/* SETICON.CMD - set the icon for all files */
/* on a disk drive that has the designated  */
/* file specification.			    */
/* EXAMPLE:				    */
/*       SETICON E:\*.ZIP C:\ICON\ZIP.ICO   */
/* This would set the icon all .ZIP files
/* in E:\ and subs to the ZIP icon located  */
/* in C:\ICON directory  		    */


/* Load the advenced REXX functions so we   */
/* can call the sysfiletree and sysseticon  */
/* functions. 				    */
call rxfuncadd sysloadfuncs,rexxutil,sysloadfuncs
call sysloadfuncs

/* Read the file specification and the name */
/* of the icon from the command line.       */
parse arg filespec iconspec

/* Get the list of all files matching the   */
/* file specification in all directories    */
/* beneath the one specified.     	    */
call sysfiletree filespec, 'filelist.','FOS'

/* Print the name of each file found, and   */
/* set the icon to the one specified.       */
do i=1 to filelist.0
   say filelist.i
   call sysseticon filelist.i, iconspec
end